# automatically generated file, don't edit



# Copyright 2011 David Cantrell, derived from data from libphonenumber
# http://code.google.com/p/libphonenumber/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
package Number::Phone::StubCountry::MM;
use base qw(Number::Phone::StubCountry);

use strict;
use warnings;
use utf8;
our $VERSION = 1.20160605144712;

my $formatters = [
                {
                  'leading_digits' => '
            1|
            2[245]
          ',
                  'pattern' => '(\\d)(\\d{3})(\\d{3,4})'
                },
                {
                  'pattern' => '(2)(\\d{4})(\\d{4})',
                  'leading_digits' => '251'
                },
                {
                  'pattern' => '(\\d)(\\d{2})(\\d{3})',
                  'leading_digits' => '
            16|
            2
          '
                },
                {
                  'leading_digits' => '
            67|
            81
          ',
                  'pattern' => '(\\d{2})(\\d{3})(\\d{3,4})'
                },
                {
                  'pattern' => '(\\d{2})(\\d{2})(\\d{3,4})',
                  'leading_digits' => '[4-8]'
                },
                {
                  'leading_digits' => '
            9(?:
              2[0-4]|
              [35-9]|
              4[137-9]
            )
          ',
                  'pattern' => '(9)(\\d{3})(\\d{4,6})'
                },
                {
                  'pattern' => '(9)([34]\\d{4})(\\d{4})',
                  'leading_digits' => '
            9(?:
              3[0-36]|
              4[0-57-9]
             )
          '
                },
                {
                  'pattern' => '(9)(\\d{3})(\\d{3})(\\d{3})',
                  'leading_digits' => '92[56]'
                },
                {
                  'pattern' => '(9)(\\d{3})(\\d{3})(\\d{2})',
                  'leading_digits' => '93'
                }
              ];

my $validators = {
                'pager' => '',
                'toll_free' => '',
                'specialrate' => '',
                'voip' => '1333\\d{4}',
                'fixed_line' => '
          1(?:
            2\\d{1,2}|
            [3-5]\\d|
            6\\d?|
            [89][0-6]\\d
          )\\d{4}|
          2(?:
            2(?:
              000\\d{3}|
              \\d{4}
            )|
            3\\d{4}|
            4(?:
              0\\d{5}|
              \\d{4}
            )|
            5(?:
              1\\d{3,6}|
              [02-9]\\d{3,5}
            )|
            [6-9]\\d{4}
          )|
          4(?:
            2[245-8]|
            [346][2-6]|
            5[3-5]
          )\\d{4}|
          5(?:
            2(?:
              20?|
              [3-8]
            )|
            3[2-68]|
            4(?:
              21?|
              [4-8]
            )|
            5[23]|
            6[2-4]|
            7[2-8]|
            8[24-7]|
            9[2-7]
          )\\d{4}|
          6(?:
            0[23]|
            1[2356]|
            [24][2-6]|
            3[24-6]|
            5[2-4]|
            6[2-8]|
            7(?:
              [2367]|
              4\\d|
              5\\d?|
              8[145]\\d
            )|
            8[245]|
            9[24]
          )\\d{4}|
          7(?:
            [04][24-8]|
            [15][2-7]|
            22|
            3[2-4]
          )\\d{4}|
          8(?:
            1(?:
              2\\d{1,2}|
              [3-689]\\d
            )|
            2(?:
              2\\d|
              3(?:
                \\d|
                20
              )|
              [4-8]\\d
            )|
            3[24]\\d|
            4[24-7]\\d|
            5[245]\\d|
            6[23]\\d
          )\\d{3}
        ',
                'mobile' => '
          17[01]\\d{4}|
          9(?:
            2(?:
              [0-4]|
              5\\d{2}|
              6[0-5]\\d
            )|
            3[0-36]\\d|
            4(?:
              0[0-4]\\d|
              [1379]\\d|
              2\\d{2}|
              4[0-589]\\d|
              5\\d{2}|
              88
            )|
            5[0-6]|
            61?\\d|
            7(?:
              3\\d|
              [789]\\d{2}
            )|
            8\\d|
            9(?:
              1\\d|
              [67]\\d{2}|
              [089]
            )
          )\\d{5}
        ',
                'personal_number' => '',
                'geographic' => '
          1(?:
            2\\d{1,2}|
            [3-5]\\d|
            6\\d?|
            [89][0-6]\\d
          )\\d{4}|
          2(?:
            2(?:
              000\\d{3}|
              \\d{4}
            )|
            3\\d{4}|
            4(?:
              0\\d{5}|
              \\d{4}
            )|
            5(?:
              1\\d{3,6}|
              [02-9]\\d{3,5}
            )|
            [6-9]\\d{4}
          )|
          4(?:
            2[245-8]|
            [346][2-6]|
            5[3-5]
          )\\d{4}|
          5(?:
            2(?:
              20?|
              [3-8]
            )|
            3[2-68]|
            4(?:
              21?|
              [4-8]
            )|
            5[23]|
            6[2-4]|
            7[2-8]|
            8[24-7]|
            9[2-7]
          )\\d{4}|
          6(?:
            0[23]|
            1[2356]|
            [24][2-6]|
            3[24-6]|
            5[2-4]|
            6[2-8]|
            7(?:
              [2367]|
              4\\d|
              5\\d?|
              8[145]\\d
            )|
            8[245]|
            9[24]
          )\\d{4}|
          7(?:
            [04][24-8]|
            [15][2-7]|
            22|
            3[2-4]
          )\\d{4}|
          8(?:
            1(?:
              2\\d{1,2}|
              [3-689]\\d
            )|
            2(?:
              2\\d|
              3(?:
                \\d|
                20
              )|
              [4-8]\\d
            )|
            3[24]\\d|
            4[24-7]\\d|
            5[245]\\d|
            6[23]\\d
          )\\d{3}
        '
              };
sub areaname { my $self = shift; my $number = $self->{number}; my %map = (
  9522000 => "Mingalar\ Mandalay",
  955645 => "Tandar",
  9582320 => "Manton",
);
      foreach my $prefix (map { substr($number, 0, $_) } reverse(1..length($number))) {
        return $map{"95$prefix"} if exists($map{"95$prefix"});
      }
      return undef;
    }
sub new {
  my $class = shift;
  my $number = shift;
  $number =~ s/(^\+95|\D)//g;
  my $self = bless({ number => $number, formatters => $formatters, validators => $validators }, $class);
  return $self if ($self->is_valid());
  $number =~ s/(^0)//g;
  $self = bless({ number => $number, formatters => $formatters, validators => $validators }, $class);
  return $self->is_valid() ? $self : undef;
}

1;
